﻿using System.Collections.Generic;

using DevExpress.XtraMap;

namespace TestProject
{
    /// <summary>
    /// 경로 공급자
    /// </summary>
    public class RouteProvider : InformationDataProviderBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 포인트 열거 가능 목록 - PointEnumerable

        /// <summary>
        /// 포인트 열거 가능 목록
        /// </summary>
        public IEnumerable<GeoPoint> PointEnumerable
        {
            get
            {
                return Data.PointList;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 데이터 - Data

        /// <summary>
        /// 데이터
        /// </summary>
        protected new RouteData Data
        {
            get
            {
                return (RouteData)base.Data;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 경로 계산하기 - CalculateRoute(point1, point2)

        /// <summary>
        /// 경로 계산하기
        /// </summary>
        /// <param name="point1">포인트 1</param>
        /// <param name="point2">포인트 2</param>
        public void CalculateRoute(GeoPoint point1, GeoPoint point2)
        {
            Data.CalculateRoute(point1, point2);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 데이터 생성하기 - CreateData()

        /// <summary>
        /// 데이터 생성하기
        /// </summary>
        /// <returns>정보 데이터 인터페이스</returns>
        protected override IInformationData CreateData()
        {
            return new RouteData();
        }

        #endregion
    }
}